using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace AvatarWrapper
{
    /*
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            graphics.PreferredBackBufferWidth = 1280;
            graphics.PreferredBackBufferHeight = 720;
            Content.RootDirectory = "Content";
            Components.Add(new GamerServicesComponent(this));
        }

        AvatarDescription avatarDesc;
        AvatarRenderer avatarRenderer;
        AvatarAnimation avatarAnimation;

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here
            base.Initialize();
            
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            Avatar.Initialize(Content);
            // TODO: use this.Content to load your game content here

            if (SignedInGamer.SignedInGamers.Count > 0)
            {
                avatarDesc = SignedInGamer.SignedInGamers[0].Avatar;
            }
            else
                avatarDesc = AvatarDescription.CreateRandom();

            avatarAnimation = new AvatarAnimation(AvatarAnimationPreset.Clap);

            avatarRenderer = new AvatarRenderer(avatarDesc, true);
            avatarRenderer.World =
                Matrix.CreateRotationY(MathHelper.ToRadians(180.0f));
            avatarRenderer.Projection =
                Matrix.CreatePerspectiveFieldOfView(MathHelper.ToRadians(45.0f),
                GraphicsDevice.Viewport.AspectRatio, .01f, 200.0f);
            avatarRenderer.View =
                Matrix.CreateLookAt(new Vector3(0, 1, 3), new Vector3(0, 1, 0),
                Vector3.Up);
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        AvatarAnimationPreset curPreset = AvatarAnimationPreset.Clap;

        int timeSinceChange = 0;
        int timeSincePresetChange = 0;
        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            if (avatarRenderer.IsLoaded)
            {
                avatarAnimation.Update(gameTime.ElapsedGameTime, true);


            }

            GamePadState gamePad = GamePad.GetState(PlayerIndex.One);

            if (gamePad.IsButtonDown(Buttons.A) && System.Environment.TickCount >= timeSinceChange + 500)
            {
                timeSinceChange = System.Environment.TickCount;
                avatarDesc = AvatarDescription.CreateRandom();

                avatarAnimation = new AvatarAnimation(curPreset);

                avatarRenderer = new AvatarRenderer(avatarDesc, true);
                avatarRenderer.World =
                    Matrix.CreateRotationY(MathHelper.ToRadians(180.0f));
                avatarRenderer.Projection =
                    Matrix.CreatePerspectiveFieldOfView(MathHelper.ToRadians(45.0f),
                    GraphicsDevice.Viewport.AspectRatio, .01f, 200.0f);
                avatarRenderer.View =
                    Matrix.CreateLookAt(new Vector3(0, 1, 3), new Vector3(0, 1, 0),
                    Vector3.Up);
            }
            if (gamePad.IsButtonDown(Buttons.X))
            {
                avatarDesc = Gamer.SignedInGamers[0].Avatar;
                avatarAnimation = new AvatarAnimation(curPreset);

                avatarRenderer = new AvatarRenderer(avatarDesc, true);
                avatarRenderer.World =
                    Matrix.CreateRotationY(MathHelper.ToRadians(180.0f));
                avatarRenderer.Projection =
                    Matrix.CreatePerspectiveFieldOfView(MathHelper.ToRadians(45.0f),
                    GraphicsDevice.Viewport.AspectRatio, .01f, 200.0f);
                avatarRenderer.View =
                    Matrix.CreateLookAt(new Vector3(0, 1, 3), new Vector3(0, 1, 0),
                    Vector3.Up);
            }

            if (gamePad.IsButtonDown(Buttons.Y) && System.Environment.TickCount >= timeSincePresetChange + 500)
            {
                timeSincePresetChange = System.Environment.TickCount;
                curPreset++;
                if (curPreset >= AvatarAnimationPreset.Wave)
                    curPreset = AvatarAnimationPreset.Celebrate;
            }


            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here
            
            avatarRenderer.Draw(avatarAnimation.BoneTransforms,
                avatarAnimation.Expression);

            base.Draw(gameTime);
        }
    }*/
}
